"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Foco = /** @class */ (function (_super) {
    tslib_1.__extends(Foco, _super);
    function Foco() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.clickCaptured = false;
        _this.focusCaptured = false;
        _this.handleDocumentClick = function (event) {
            if (!_this.clickCaptured && _this.props.onClickOutside) {
                _this.props.onClickOutside(event);
            }
            _this.clickCaptured = false;
        };
        _this.handleInnerClick = function () {
            _this.clickCaptured = true;
        };
        _this.handleDocumentFocus = function (event) {
            if (!_this.focusCaptured && _this.props.onFocusOutside) {
                _this.props.onFocusOutside(event);
            }
            _this.focusCaptured = false;
        };
        _this.handleInnerFocus = function () {
            _this.focusCaptured = true;
        };
        return _this;
    }
    Foco.prototype.componentDidMount = function () {
        this.initDOMListeners();
    };
    Foco.prototype.componentWillUnmount = function () {
        this.removeDOMListeners();
    };
    Foco.prototype.render = function () {
        return (react_1.default.createElement("span", { className: this.props.className, style: this.props.style, onMouseDown: this.handleInnerClick, onFocus: this.handleInnerFocus, children: this.props.children }));
    };
    Foco.prototype.initDOMListeners = function () {
        document.addEventListener('mousedown', this.handleDocumentClick);
        document.addEventListener('focus', this.handleDocumentFocus, true);
    };
    Foco.prototype.removeDOMListeners = function () {
        document.removeEventListener('mousedown', this.handleDocumentClick);
        document.removeEventListener('focus', this.handleDocumentFocus);
    };
    return Foco;
}(react_1.default.Component));
exports.default = Foco;
